var __MAServiceStartTime__ = Date.now();

(function(global){
	var WeixinJSBridge = global.WeixinJSBridge;
	var Reporter = global.Reporter;
	var wx = global.wx;
	if(!Reporter){
		console.warn("WAService Reporter does not export, please replace `var Reporter` to `var Reporter=this.Reporter` in WAService.js for exception report.");
		Reporter = {
			errorReport: function(){}, 
			surroundThirdByTryCatch: function(e){
				return e.apply(e, arguments);
			}, 
		};
	}

	if(!WeixinJSBridge || !WeixinJSBridge.invoke){
		throw new Error("JSBridge does not export");
	}

	if(!wx){
		throw new Error("Need import wx service at first.");
	}

	function surroundByTryCatchFactory(e, t) {
		return !0 === __wxConfig.karmaTest ? e : function() {
			try {
				return e.apply(e, arguments);
			} catch (e) {
				if ("[object Error]" === Object.prototype.toString.apply(e)) {
					if ("AppServiceSdkKnownError" == e.type) throw e;
					Reporter.errorReport({
						key: "appServiceSDKScriptError",
						error: e,
						extend: t
					});
				}
			}
		};
	}

	function onMethod(e, t) {
		WeixinJSBridge.on(e, (0, surroundByTryCatchFactory)(t, "at api " + e + " callback function"));
	}

	function invokeMethod(e) {
		var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, n = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {};
		t = (0, Object.assign)({}, t);
		var o = {};
		for (var i in t) "function" == typeof t[i] && (!0 === __wxConfig.karmaTest ? o[i] = t[i] : o[i] = Reporter.surroundThirdByTryCatch(t[i], "at api " + e + " " + i + " callback function"), 
			delete t[i]);
		var a = {};
		for (var c in n) "function" == typeof n[c] && (a[c] = (0, surroundByTryCatchFactory)(n[c], "at api " + e + " " + c + " callback function"));
		WeixinJSBridge.invoke(e, t, function(t) {
			t.errMsg = t.errMsg || e + ":ok";
			var n = 0 === t.errMsg.indexOf(e + ":ok"), r = 0 === t.errMsg.indexOf(e + ":cancel"), i = 0 === t.errMsg.indexOf(e + ":fail");
			if ("function" == typeof a.beforeAll && a.beforeAll(t), n) "function" == typeof a.beforeSuccess && a.beforeSuccess(t), 
				"function" == typeof o.success && o.success(t), "function" == typeof a.afterSuccess && a.afterSuccess(t); else if (r) t.errMsg = t.errMsg.replace(e + ":cancel", e + ":fail cancel"), 
				"function" == typeof o.fail && o.fail(t), "function" == typeof a.beforeCancel && a.beforeCancel(t), 
				"function" == typeof o.cancel && o.cancel(t), "function" == typeof a.afterCancel && a.afterCancel(t); else if (i) {
					"function" == typeof a.beforeFail && a.beforeFail(t), "function" == typeof o.fail && o.fail(t);
					var c = !0;
					"function" == typeof a.afterFail && (c = a.afterFail(t));
				}
			"function" == typeof o.complete && o.complete(t), "function" == typeof a.afterAll && a.afterAll(t);
		});
	}

	var SupportSeniorApi = ["getFaceImage",
                             "umengCountEvent",
                             "AliFeedback",
                             "tf_auth_alipay",
                             "tf_pay_alipay",
                             "tf_pay_wechat",
                             "openAppMarket",
                             "onRegisterForRemoteNotifications",
                             "openWechat",
                             "wechatAuth"]

	var minapp = {

		invokeMethod: invokeMethod,
		onMethod: onMethod,

		//url
		openURL: function(options){
		    if(options && options.url && options.url.includes("wechat://")){
		        invokeMethod("openWechat")
		    }else{
			    invokeMethod("ma_openURL", options);
		    }
		},

		//url
		//return: {canOpen: true}
		canOpenURL: function(options){
			invokeMethod("ma_canOpenURL", options);
		},

		onOpenURL: function(fn){
			onMethod("ma_onOpenURL", fn);
		},

	};

    SupportSeniorApi.map(o=>{
        minapp[o] = function(options){
            invokeMethod(o, options);
        }
    })

	var ma = {};
	for (var key in minapp) !function(k) {
		ma.__defineGetter__(k, function() {
			return "function" == typeof minapp[k] ? surroundByTryCatchFactory(minapp[k], "ma." + k) : minapp[k];
		});
	}(key);

	global.minapp = wx.minapp = ma;

})(this);

var __MAServiceEndTime__ = Date.now();


